var Intent = null,
    File = null,
    Uri = null,
    main = null;
var cacheCaleState=false;
var os=null;

function initCacheSize ()
{
    var formatedSize;
    if(os=="Android")
    {
        formatedSize=formatSize(calcCache4Android());
        cacheCaleState=true;
    }
    else if(os=="iOS")
    {
        calcCache(function(size)
        {
            cacheCaleState=true; 
	        formatedSize=formatSize(size);
	    });
    }
    else
    {
        mui.toast("未知的设备类型，无法计算缓存");
        cacheCaleState=false;
    }
    return formatedSize;
}

/**
 * 计算缓存大小  官方提供方法，用于iOS
 */
function calcCache(callback)
{
    console.log("开始计算缓存大小");
    var finalSize = -1;
    plus.cache.calculate(function(size)
    {
        console.log(size + "byte");
        var sizeInt = parseInt(size);
        console.log("sizeInt" + sizeInt);
        return callback(finalSize);
    });
}

function calcCache4Android()
{
    var cacheSize=0;
    console.log("start calc android");
    var sdRoot = main.getCacheDir();
    var files = plus.android.invoke(sdRoot,"listFiles");
    cacheSize += getFolderSize(files); 
    console.log("android size-->"+cacheSize);
    return cacheSize;
}

function getFolderSize(files)
{
    var size = 0;
    var len = files.length;
    for(var i = 0; i < len; i++)
    {
        // 如果下面还有文件
        if(files[i].isDirectory())
        {
            size = size + getFolderSize(files[i].listFiles());
        }
        else if(!files[i].isHidden())
        {
            size = size + files[i].length();
        }
    }
    return size;
}

function formatSize(size)
{
	var fileSizeString;
	size=parseInt(size);
	console.log("我是size"+size);
	if(size == 0)
	{
	    fileSizeString = "0B";
	}
	else if(size < 1024)
	{
	    fileSizeString = size + "B";
	}
	else if(size < 1048576)
	{
	    fileSizeString = (size/1024).toFixed(2) + "KB";
	}
	else if (size < 1073741824)
	{
	    console.log("Mb"+size);
		fileSizeString = (size/1048576).toFixed(2) + "MB";
		console.log("/ after"+fileSizeString);
	}
	else
	{
	    fileSizeString = (size/1073741824).toFixed(2) + "GB";
	}
	return fileSizeString;
}

 /**
 * 清除缓存  
 */
function clearCache(callback)
{
    plus.storage.clear();
    plus.cache.clear(function()
    {
		console.log("清除了~~~return");
        return callback();
    });
}

function clearAllCache4Android()
{
	console.log("清空所有缓存");
	console.log("main"+main.getCacheDir());
	var sdRoot = main.getCacheDir();
	var files = plus.android.invoke(sdRoot,"listFiles");
	deleteAllFile(files);   
}

function deleteAllFile(files)
{
    var len = files.length;
    for(var i = 0; i < len; i++)
    {
        if(files[i].isDirectory())
        {
            deleteAllFile(files[i].listFiles());
        }
        else if(!files[i].isHidden())
        {
            files[i].delete();
            console.log("delete file:"+files[i]);
        }
    }
}


mui.plusReady(function()
{
    os=plus.os.name;
    if(os == "Android")
    {
        main = plus.android.runtimeMainActivity();
        Intent = plus.android.importClass("android.content.Intent");
        File = plus.android.importClass("java.io.File");
        Uri = plus.android.importClass("android.net.Uri");
    }

    cacheDom.addEventListener('tap', function()
    {
    	//mui.toast("正在计算缓存大小，请稍等片刻 ...");
    	var size = initCacheSize();
        mui.confirm("当前缓存大小 "+size+"，要清空缓存吗？ 清空后 App 中的数据将会被清理，用户需重新登录", "清空缓存", ["取消", "清空"], function(e)
        {
            if(e.index == 1)
            {
                console.log("cacheCaleState:"+cacheCaleState);
                if(os=="Android")
                {
                    if(cacheCaleState==true)
                    {
                    	clearAllCache4Android();    
                    	mui.toast("缓存已清空");
                	}
                	else
                	{
                    	mui.toast("缓存计算中 ...");
                	}
            	}
            	else if(os=="iOS")
            	{
                	clearCache(function()
	                {
	                    mui.toast("缓存已清空");
	                });
            	}
            }
        }, 'div');
    }, false);
});