// 许可协议：萌绘图站开发组 MIT
var FileIO = {};
FileIO.readFile = function (file, callback)
{
    var rawFile = new XMLHttpRequest();
    rawFile.open("GET", file, false);
    rawFile.onreadystatechange = function ()
    {
        if(rawFile.readyState === 4)
        {
            if(rawFile.status === 200 || rawFile.status == 0)
            {
                var rawText = rawFile.responseText;
                callback.call(window, rawText);
            }
            else
            {
            	callback.call(this, null);
            }
        }
    }
    rawFile.send(null);
};

// Load CSS file 
FileIO.loadCss = function(filename)
{
    var fileref=document.createElement("link")
    fileref.setAttribute("rel", "stylesheet")
    fileref.setAttribute("type", "text/css")
    fileref.setAttribute("href", filename)

    document.getElementsByTagName("head")[0].appendChild(fileref)
}

// Load JS file and callback
FileIO.loadJs = function (url, callback)
{
    var script = document.createElement("script")
    script.type = "text/javascript";
    
    script.onload = function(){
        callback.call(this);
    };

    script.src = url;
    document.getElementsByTagName("head")[0].appendChild(script);
}

// Convert IMGSRC to B64
// https://stackoverflow.com/questions/22172604/convert-image-url-to-base64
FileIO.img2B64 = function(src, cb)
{
	var img = new Image();
	img.src = src;
	img.onload = function ()
	{
		var canvas = document.createElement("canvas");
		canvas.width = img.width;
		canvas.height = img.height;
		var ctx = canvas.getContext("2d");
		ctx.drawImage(img, 0, 0);
		var dataURL = canvas.toDataURL("image/png");
		cb.call(this, dataURL.replace(/^data:image\/(png|jpg);base64,/, ""))
	}
}
