var Follow = {};

/*
 * 创建 Follow 关系
 */
Follow.create = function(uid, cb)
{
	mui.ajax(MOEAPI_URL('follow', 'basic', uid), {
        type: 'put',
        contentType: 'application/json; charset=utf-8',
        timeout: 10000,
        success: function(data, status, xhr)
        {
        	mui.toast('关注成功');
        	cb && cb.call(this, true);
        },
        error: function(xhr, type, errorThrown) 
        {
        	switch (xhr.status)
        	{
        		case 401: mui.toast('请先登录'); break;
        		case 403: mui.toast('不允许关注自己或对方禁止关注'); break;
        		case 404: mui.toast('关注对象不存在'); break;
        		default: mui.toast('关注失败');
        	}
            
            cb && cb.call(this, false);
        },
        headers: MOEAPI_AK_APPEND({})
    });
}

/*
 * 解除 Follow 关系
 */
Follow.destroy = function(uid, cb)
{
	mui.ajax(MOEAPI_URL('follow', 'basic', uid), {
        type: 'delete',
        contentType: 'application/json; charset=utf-8',
        timeout: 10000,
        success: function(data, status, xhr)
        {
        	mui.toast('取消关注成功');
        	cb && cb.call(this, true);
        },
        error: function(xhr, type, errorThrown) 
        {
            switch (xhr.status)
        	{
        		case 401: mui.toast('请先登录'); break;
        		default: mui.toast('取消关注失败');
        	}
            cb && cb.call(this, false);
        },
        headers: MOEAPI_AK_APPEND({})
    });
}

/*
 * 从列表中点关注按钮
 * 如：关注、搜索列表
 */
Follow.tapFromList = function(e)
{
	var $btn = e.target;
	var $p = $btn.parentNode.parentNode.parentNode;
	var following = $btn.classList.contains('gray');
	var uid = $p.getAttribute('data-uid');
	
	if (following)
	{
		Follow.destroy(uid, function(e) {
			if (e) {
				$btn.classList.remove('gray');
				$btn.innerText = '关注';
			}
		})
	}
	else
	{
		Follow.create(uid, function(e) {
			if (e) {
				$btn.classList.add('gray');
				$btn.innerText = '已关注';
			}
		})
	}
}
