/**
 * Push Receiver
 */
MAReceiver = function(msg)
{
	switch (msg.type)
	{
		case 'message': marcv_message(msg.body); break;
		case 'openmsg': marcv_openmsg(msg.body); break;
		
		case 'follow': marcv_follow(msg.body); break;
		case 'openfollow': marcv_openfollow(); break;
	}
}

// 接收来自推送的私信并处理
function marcv_message(msg)
{
	var wvid = plus.webview.getWebviewById('message.html?uid=' + msg.from);
	var indexPage = plus.webview.getWebviewById('index');
	if (wvid)
	{
		// 聊天窗口已打开推送到聊天窗口
		wvid.evalJS("messageApp.pushReceiver('"+JSON.stringify(msg)+"')");
		
		// 首页消息收件箱同步
		msg.count = 0;
		indexPage.evalJS("notifyApp.receiver('"+JSON.stringify(msg)+"')");
	}
	else
	{
		// 聊天窗口未打开时显示通知
		if(plus.storage.getItem("opt_ntyMessage") != "off") 
		{
			plus.push.clear();
			plus.push.createMessage(
				decodeURIComponent(msg.body), 
				'{"type":"openmsg","body":"'+msg.from+'"}', 
				{
					title: msg.fromname,
					cover: true,
					icon: '_www/img/logo.png'
				}
			);
		}
		indexPage.evalJS("notifyApp.receiver('"+JSON.stringify(msg)+"')");
	}
}

// 请求打开私信窗口
function marcv_openmsg(msg)
{
	mui.openWindow({
		url: 'message.html?uid='+msg,
		show:{
			autoShow: true,
			aniShow: "pop-in"
	    },
	    waiting:{
        	autoShow: false
        }
	});
}

// 新关注提醒
function marcv_follow(msg)
{
	if(plus.storage.getItem("opt_ntyFollow") != "off") 
	{
		plus.push.createMessage(
			msg.username + ' 关注了你！', 
			'{"type":"openfollow"}', 
			{
				title: '新粉丝',
				cover: false,
				icon: '_www/img/logo.png'
			}
		);
	}
}

// 请求打开个人空间
function marcv_openfollow()
{
	mui.openWindow({
		url: 'my-space.html',
		show:{
			autoShow: true,
			aniShow: "pop-in"
	    },
	    waiting:{
        	autoShow: false
        }
	});
}